# -*- coding: utf-8 -*-
from pyhaskell.interpreter.module import CoreMod, expose_var
from pyhaskell.interpreter.haskell import Value, Symbol, make_constructor


mod = CoreMod("base:System.IO")


@expose_var(mod, "putStrLn", [Value])
def putStrLn(a):
    """Print a list of Chars and a newline to stdout."""
    t = a
    str_ = ''
    while t.numargs() > 0:
        str_ += t.getarg(0).tostr()
        t = t.getarg(1)
    print str_
    unit = make_constructor(Symbol.get_symbol("()"), [])
    return make_constructor(Symbol.get_symbol("IO"), [unit])
