# -*- coding: utf-8 -*-
from pyhaskell.interpreter.module import CoreMod, expose_var, get_var
from pyhaskell.interpreter.primtype import Char, Int
from pyhaskell.interpreter.haskell import Value, Symbol, make_constructor


mod = CoreMod("ghc-prim:GHC.Show")
CoreMod.all_modules['base:GHC.Show'] = mod
#mod.qvars["$fShow[]"] = Int(1)
mod.qvars["$fShowInt"] = Int(2)
mod.qvars["$fShowInteger"] = Int(2)
mod.qvars["$fShowChar"] = Int(3)


@expose_var(mod, "show", [Int, Value])
def show(ty, a):
    cons = Symbol.get_symbol(":")
    nil = make_constructor(Symbol.get_symbol("[]"), [])

    # Convert a integer to a list
    if ty == get_var(mod, "$fShowInt"):
        current = nil
        str_ = a.tostr()
        for i in range(len(str_) - 1, -1, -1):
            current = make_constructor(cons, [Char(str_[i]), current])
        return current

    # Put a Char in a list
    elif ty == get_var(mod, "$fShowChar"):
        return make_constructor(cons, [a, nil])

    # Convert a list to a char list
    #elif ty == get_var(mod, "$fShow[]"):
    else:
        print a
        raise NotImplementedError
