# -*- coding: utf-8 -*-

# XXX gross hack
from pypy import conftest
class option:
    view = False
    viewloops = True

conftest.option = option

from pyhaskell.interpreter.haskell import *
from pyhaskell.interpreter.primtype import Int
from pyhaskell.interpreter.test.test_haskell import (
        fromto, app, ForwardReference, function, to_list,
        take, from_, map_, succ, iterate, filter_, not_, id_, append,
        prim_seq, prim_sub, prim_add, w_true, w_nil, cons, length_)


# jit tests
from pypy.jit.metainterp.test.support import LLJitMixin


class TestLLtype(LLJitMixin):
    def test_append(self):
        n = Var("n")
        m = Var("m")
        x = Var("x")
        xs = Var("xs")
        f = ForwardReference()
        f.become(function("f", [
            ([Int(0), n], n),
            ([n, m], app(prim_seq, m, app(f, app(prim_sub, n, Int(1)),
                                             app(prim_add, n, m))))], recursive=True))
        g = ForwardReference()
        g.become(function("g", [
            ([Int(0)], w_true),
            ([n], app(g, app(prim_sub, n, Int(1))))], recursive=True))

        bottom = ForwardReference()
        bottom.become(function("bottom", [
            ([], app(bottom))], recursive=True))

        last = ForwardReference()
        last2 = ForwardReference()
        last.become(function("last", [
            ([cons(x, xs)], app(last2, xs, x))], recursive=True))
        last2.become(function("last2", [
            ([w_nil, n], n),
            ([xs, m], app(last, xs))], recursive=True))

        # l = app(length_, app(fromto, Int(1), Int(100)))
        # l = app(take, Int(100), app(iterate, not_, w_true))
        # l = app(filter_, id_, app(take, Int(100),
        #                           app(iterate, not_, w_true)))
        # l = app(map_, succ, app(fromto, Int(1), Int(100)))
        # l = app(take, Int(100), app(from_, Int(1)))
        # l = app(map_, succ, app(take, Int(100), app(from_, Int(1))))
        # l = to_list(range(100))
        # l = app(fromto, Int(0), Int(1200))
        l = app(take, Int(100), app(from_, Int(0)))
        # l = app(append, app(fromto, Int(1), Int(100)), app(fromto, Int(1), Int(100)))

        def interp(i):
            if i < 0:
                result = evaluate_hnf(app(last, l))
            else:
                result = evaluate_hnf(app(f, Int(i), Int(0)))
                #result = evaluate_hnf(app(bottom))
            return result.tostr()

        interp(-100)
        self.meta_interp(interp, [-100], listcomp=True, backendopt=True,
                         listops=True)
