#!/usr/bin/env pypy
# -*- coding: utf-8 -*-
"""
A simple standalone target for the Haskell interpreter.
"""
import sys

from pypy.jit.codewriter.policy import JitPolicy

from pyhaskell import main


def entry_point(argv):
    return main.main(argv)


def target(driver, args):
    return entry_point, None


def jitpolicy(self):
    return JitPolicy()


if __name__ == '__main__':
    entry_point(sys.argv)
