#!/usr/bin/env python
# -*- coding: utf-8 -*-
import fnmatch
import os
from subprocess import call


def make_hcj(filename):
    core2js = "./core/core2js"
    hcj = filename.replace(".hcr", ".hcj")
    print filename, " -> ", hcj
    call([core2js, filename, hcj])


def main():
    print "Making hcj files from hcr files"
    print "-----------------------------------"
    for root, dirs, files in os.walk('./ghc_modules/'):
        for filename in fnmatch.filter(files, '*.hcr'):
            make_hcj(os.path.join(root, filename))


if __name__ == "__main__":
    main()
