-- Test from http://learnyouahaskell.com/
main = putStrLn ("Sorted?: " ++ (show (quicksort [10,2,5,3,1,6,7,4,2,3,4,8,9])))

quicksort :: (Ord a) => [a] -> [a]
quicksort [] = []
quicksort (x:xs) =
    let smallerSorted = quicksort [a | a <- xs, a <= x]
        biggerSorted = quicksort [a | a <- xs, a > x]
    in  smallerSorted ++ [x] ++ biggerSorted

